(**************************************************************************)
(*         Equivalences of the different kinds of finite automata         *)
(**************************************************************************)

Implicit Arguments On.

Require Export DFA.
Require Export NFA.
Require Export NFA_eps.

(**************************************************************************)
(*                     Equivalence of DFA's and NFA's                     *)
(**************************************************************************)

Axiom NFA_equiv_DFA : (A,St:Set)(I:(fset A))(L:(wordset A))
  (nf_regularset St I L) -> (regularset St I L).

(**************************************************************************)
(*           Equivalence of NFA's with or without epsilon-moves           *)
(**************************************************************************)

Axiom NFE_equiv_NFA : (A,St:Set)(I:(fset A))
  (eps:A)~(member eps I) ->
  (L:(wordset A))
  (nfe_regularset St eps I L) -> (nf_regularset St I L).

(* NFE's and NFE''s are equivalent (see NFA_eps.v) so we have
   the equivalence of NFA's and NFE''s. *)

Theorem NFE'_equiv_NFA : (A,St:Set)(I:(fset A))
  (eps:A)~(member eps I) ->
  (L:(wordset A))
  (nfe'_regularset St eps I L) -> (nf_regularset St I L).

(* From the two previous theorems, we easily derive the equivalence
   of DFA's and NFE''s. *)

Theorem NFE'_equiv_DFA : (A,St:Set)(I:(fset A))
  (eps:A)~(member eps I) ->
  (L:(wordset A))
  (nfe'_regularset St eps I L) -> (regularset St I L).

