
(**************************************************************************)
(*                     Test of the extracted program                      *)
(**************************************************************************)

#use "compiler.ml";;


(* First we introduce pretty-printers *)

let rec int_of_nat = function
    O   -> 0
  | S n -> succ (int_of_nat n)
;;

let pp_for_nat n = Format.print_int (int_of_nat n);;

#install_printer pp_for_nat;;


let pp_for_charoption = function
    None   -> Format.print_string "epsilon"
  | Some a -> Format.print_char a
;;

#install_printer pp_for_charoption;;


let pp_for_3tuple (Pair (x, Pair (y,z))) = 
  Format.print_string "(" ; 
  pp_for_nat x ;
  Format.print_string ", " ;
  pp_for_charoption y ;
  Format.print_string ", " ;
  pp_for_nat z ;
  Format.print_string ")"
;;


let pp_for_lists pp0 l =
  let rec pp = function
    Nil        -> ()
  | Cons (x,l) -> Format.print_char ' ' ; pp0 x ;
                  if l<>Nil then Format.print_string ";" ;
                  pp l
  in Format.print_string "[" ; pp l ; Format.print_string " ]"
;;

let pp_for_co_lists = (pp_for_lists pp_for_charoption);;
#install_printer pp_for_co_lists;;

let pp_for_nat_lists = (pp_for_lists pp_for_nat);;
#install_printer pp_for_nat_lists;;

let pp_for_3tuple_lists = (pp_for_lists pp_for_3tuple);;
#install_printer pp_for_3tuple_lists;;


(* Automaton for the regular expression r1 = 'a*'. *)

let word_b = Cons (symbol_b, Nil);;

let r1 = Reg_star (Reg_word word_b);;

let a1 = regexp_nfe'_automaton r1;;


(* Automaton for the regular expression r2 = 'ab*'. *)

let word_a = Cons (symbol_a, Nil);;

let r2 = Reg_conc (Reg_word word_a, r1);;

let a2 = regexp_nfe'_automaton r2;;


(* Automaton for the regular expression r3 = 'ab*+b'. *)

let r3 = Reg_union (r2, Reg_word word_b);;

let a3 = regexp_nfe'_automaton r3;;
