(**************************************************************************)
(*                Non elementary properties of finite sets                *)
(**************************************************************************)

Implicit Arguments On.

Require Properties.


Axiom subset_prod33 : (A,B,C:Set)(a:(fset A))(b:(fset B))(c:(fset C))
  (x:C)(d:(fset A*B*C))
  (subset d (product a (product b c))) ->
  (subset d (product a (product b (add x c))) ).

Axiom subset_prod32 : (A,B,C:Set)(a:(fset A))(b:(fset B))(c:(fset C))
  (x:B)(d:(fset A*B*C))
  (subset d (product a (product b c))) ->
  (subset d (product a (product (add x b) c)) ).

Axiom subset_prod31 : (A,B,C:Set)(a:(fset A))(b:(fset B))(c:(fset C))
  (x:A)(d:(fset A*B*C))
  (subset d (product a (product b c))) ->
  (subset d (product (add x a) (product b c)) ).

Lemma add_in_product : 
  (St,A:Set)(Q:(fset St))(I:(fset A))(q,q':St)(a:A)(delta:(fset St*A*St))

  (member q Q) ->
  (member a I) ->
  (subset delta (product Q (product I Q))) ->

  (subset (add (q',(a,q)) delta)
          (product (add q' Q) (product I (add q' Q)))).

Intros St A Q I q q' a delta H_q H_a H_delta.
Apply subset_add_trans.
Auto.
Apply subset_trans_product_left.
Apply subset_prod33.
Assumption.
Save.


