(**************************************************************************)
(*         Special properties for finite sets of natural numbers          *)
(**************************************************************************)

Implicit Arguments On.

Require FiniteSets.
Require PolyList.
Require Max.
Require Properties.


Lemma outside_list : (l:(list nat)) { n:nat | ~(In nat n l) }.
Proof.
Intro l.
Exists (S (max_of_list l)).
Exact (Smax_outside l).
Save.

Lemma outside : (E:(fset nat)) { n:nat | ~(member n E) }.
Proof.
Intro E.
Elim (outside_list (list_of_fset E)).
Intros x Hx.
Exists x.
Red. Intro H.
Generalize (list_of_def_1 H).
Auto.
Save.

Lemma In_couple : (l:(list nat*bool))(n:nat)(b:bool)
  (In nat*bool (n,b) l) -> (In nat n (map [x:nat*bool](Fst x) l)).
Proof.
Induction l.
Auto.
 
Intros.
Simpl.
Elim H0.
Intros equ.
Rewrite -> equ.
Auto.
 
Intros H1.
Right.
Apply H with b:=b.
Assumption.
Save.

Lemma outside2_list : (l:(list nat*bool)) { x:nat*bool | ~(In nat*bool x l) }.
Proof.
Intro l.
Exists (S (max_of_list (map [x:nat*bool](Fst x) l)) , true).
Generalize (Smax_outside (map [x:nat*bool](Fst x) l)).
Intros H.
Red.
Intros H1.
Generalize (In_couple H1) .
Auto.
Save.

Lemma outside2 : (E:(fset nat*bool)) { x:nat*bool | ~(member x E) }.
Proof.
Intro E.
Elim (outside2_list (list_of_fset E)).
Intros x Hx.
Exists x.
Red. Intro H.
Generalize (list_of_def_1 H).
Auto.
Save.
