(**************************************************************************)
(*                       Words on a finite alphabet                       *)
(**************************************************************************)

(* Given a type A, words over A are finite-length A-sequences.
   We use the module PolyList of polymorphic lists to represent
   finite-length sequences.

   This way, we get all standard definitions and properties over
   polymorphic lists that are already defined in ther standard library,
   as length or concatenation for instance.
 *)

Require PolyList.

Definition word : Set -> Set := [A:Set](list A).

(* The null (or empty) word *)

Definition epsilon := nil.
